- Main Page
- Packages
- Classes
- Files
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# smjg.libs.sdwf.windowbase.WindowClass Class Reference

The smjg.libs.sdwf.windowbase.WindowClass class represents a Windows window class. More...

List of all members.

## Public Member Functions
| this (Application app)
| Constructs a new WindowClass with the default icon and mouse cursor.
void | register ()
Properties
HICON | icon ()
| The window's icon.
HICON | icon (HICON i)
| The window's icon.
HICON | icon (uint id)
| The window's icon.
HICON | icon (string name)
| The window's icon.
HICON | smallIcon ()
| The window's taskbar icon.
HICON | smallIcon (HICON i)
| The window's taskbar icon.
HICON | smallIcon (uint id)
| The window's taskbar icon.
HICON | smallIcon (string name)
| The window's taskbar icon.
Icon | icon ()
| The window's icon.
Icon | icon (Icon i)
| The window's icon.
void | icon (HICON i)
| The window's icon.
void | icon (uint id)
| The window's icon.
void | icon (string name)
| The window's icon.
Icon | smallIcon ()
| The window's taskbar icon.
Icon | smallIcon (Icon i)
| The window's taskbar icon.
void | smallIcon (HICON i)
| The window's taskbar icon.
void | smallIcon (uint id)
| The window's taskbar icon.
void | smallIcon (string name)
| The window's icon.
MouseCursor | mouseCursor ()
| The window's mouse cursor.
MouseCursor | mouseCursor (MouseCursor c)
| The window's mouse cursor.
void | mouseCursor (HCURSOR c)
| The window's mouse cursor.
void | mouseCursor (uint id)
| The window's mouse cursor.
void | mouseCursor (string name)
| The window's mouse cursor.
MouseCursor | mouseCursor (void *n)
| The window's mouse cursor.
deprecated HCURSOR | cursor ()
| The window's mouse cursor.
deprecated HCURSOR | cursor (HCURSOR c)
| The window's mouse cursor.
deprecated HCURSOR | cursor (uint id)
| The window's mouse cursor.
deprecated HCURSOR | cursor (string name)
| The window's mouse cursor.
HBRUSH | background ()
| The window's background brush.
HBRUSH | background (HBRUSH h)
| The window's background brush.
HBRUSH | background (COLOUR systemColour)
| The window's background colour.
HBRUSH | background (Brush b)
| The window's background brush.
HBRUSH | background (RGBColour colour)
| The window's background colour.
LPCTSTR | menu ()
| The window's menu bar.
LPCTSTR | menu (LPCTSTR i)
| The window's menu bar.
LPCTSTR | menu (uint id)
| The window's menu bar.
LPCTSTR | menu (string name)
| The window's menu bar.
string | name ()
| The name by which this window class will be registered.
string | name (string n)
| The name by which this window class will be registered.
## Static Public Member Functions
static | assert (_smallIconHandle.offsetof-_size.offsetof==WNDCLASSEXA.sizeof-HICON.sizeof)

## Detailed Description

The smjg.libs.sdwf.windowbase.WindowClass class represents a Windows window class.

WindowClass is a wrapper around the API `WNDCLASSEXA` structure. It is used to specify some characteristics of a window.

## Constructor & Destructor Documentation

smjg.libs.sdwf.windowbase.WindowClass.this | ( | Application | app | ) |

Constructs a new WindowClass with the default icon and mouse cursor.

Parameters:

  | app | the application instance for which this class is to be registered.

## Member Function Documentation

static smjg.libs.sdwf.windowbase.WindowClass.assert | ( | _smallIconHandle.offsetof-_size. | offsetof = `=WNDCLASSEXA.sizeof-HICON.sizeof` | ) | `[static]`

HICON smjg.libs.sdwf.windowbase.WindowClass.icon | ( |  | ) |

The window's icon.

HICON smjg.libs.sdwf.windowbase.WindowClass.icon | ( | HICON | i | ) |

The window's icon.

Parameters:

  | i | a raw icon handle, such as the result of a call to stockIcon.

HICON smjg.libs.sdwf.windowbase.WindowClass.icon | ( | uint | id | ) |

The window's icon.

Parameters:

  | id | numeric ID of the icon resource.

HICON smjg.libs.sdwf.windowbase.WindowClass.icon | ( | string | name | ) |

The window's icon.

Parameters:

  | name | name of the icon resource.

HICON smjg.libs.sdwf.windowbase.WindowClass.smallIcon | ( |  | ) |

The window's taskbar icon.

The window's small icon, i.e. the icon displayed in the taskbar. It is seldom necessary to set this, but it is provided for the sake of completeness.

HICON smjg.libs.sdwf.windowbase.WindowClass.smallIcon | ( | HICON | i | ) |

The window's taskbar icon.

The window's small icon, i.e. the icon displayed in the taskbar. It is seldom necessary to set this, but it is provided for the sake of completeness.

Parameters:

  | i | a raw icon handle.

HICON smjg.libs.sdwf.windowbase.WindowClass.smallIcon | ( | uint | id | ) |

The window's taskbar icon.

The window's small icon, i.e. the icon displayed in the taskbar. It is seldom necessary to set this, but it is provided for the sake of completeness.

Parameters:

  | id | numeric ID of the icon resource.

HICON smjg.libs.sdwf.windowbase.WindowClass.smallIcon | ( | string | name | ) |

The window's taskbar icon.

The window's small icon, i.e. the icon displayed in the taskbar. It is seldom necessary to set this, but it is provided for the sake of completeness.

Parameters:

  | name | name of the icon resource.

Icon smjg.libs.sdwf.windowbase.WindowClass.icon | ( |  | ) |

The window's icon.

Since:
  0.51 (previously returned a raw handle)

Status:
  test

Icon smjg.libs.sdwf.windowbase.WindowClass.icon | ( | Icon | i | ) |

The window's icon.

Since:
  0.51

Status:
  test

void smjg.libs.sdwf.windowbase.WindowClass.icon | ( | HICON | i | ) |

The window's icon.

Status:
  done

void smjg.libs.sdwf.windowbase.WindowClass.icon | ( | uint | id | ) |

The window's icon.

Parameters:

  | id | numeric ID of the icon resource.

Status:
  done

void smjg.libs.sdwf.windowbase.WindowClass.icon | ( | string | name | ) |

The window's icon.

Parameters:

  | name | name of the icon resource.

Status:
  test

Icon smjg.libs.sdwf.windowbase.WindowClass.smallIcon | ( |  | ) |

The window's taskbar icon.

The window's small icon, i.e. the icon displayed in the taskbar. It is seldom necessary to set this, but it is provided for the sake of completeness.

Since:
  0.51 (previously returned a raw handle)

Status:
  test

Icon smjg.libs.sdwf.windowbase.WindowClass.smallIcon | ( | Icon | i | ) |

The window's taskbar icon.

The window's small icon, i.e. the icon displayed in the taskbar. It is seldom necessary to set this, but it is provided for the sake of completeness.

Since:
  0.51

Status:
  test

void smjg.libs.sdwf.windowbase.WindowClass.smallIcon | ( | HICON | i | ) |

The window's taskbar icon.

The window's small icon, i.e. the icon displayed in the taskbar. It is seldom necessary to set this, but it is provided for the sake of completeness.

Status:
  test

void smjg.libs.sdwf.windowbase.WindowClass.smallIcon | ( | uint | id | ) |

The window's taskbar icon.

The window's small icon, i.e. the icon displayed in the taskbar. It is seldom necessary to set this, but it is provided for the sake of completeness.

Parameters:

  | id | numeric ID of the icon resource.

Status:
  test

void smjg.libs.sdwf.windowbase.WindowClass.smallIcon | ( | string | name | ) |

The window's icon.

Parameters:

  | name | name of the icon resource.

Status:
  test

MouseCursor smjg.libs.sdwf.windowbase.WindowClass.mouseCursor | ( |  | ) |

The window's mouse cursor.

Since:
  0.51

Status:
  test

MouseCursor smjg.libs.sdwf.windowbase.WindowClass.mouseCursor | ( | MouseCursor | c | ) |

The window's mouse cursor.

Since:
  0.51

Status:
  done

void smjg.libs.sdwf.windowbase.WindowClass.mouseCursor | ( | HCURSOR | c | ) |

The window's mouse cursor.

Since:
  0.51

Status:
  test

void smjg.libs.sdwf.windowbase.WindowClass.mouseCursor | ( | uint | id | ) |

The window's mouse cursor.

Parameters:

  | id | numeric ID of the cursor resource.

Since:
  0.51

Status:
  test

void smjg.libs.sdwf.windowbase.WindowClass.mouseCursor | ( | string | name | ) |

The window's mouse cursor.

Parameters:

  | name | name of the cursor resource.

Since:
  0.51

Status:
  test

MouseCursor smjg.libs.sdwf.windowbase.WindowClass.mouseCursor | ( | void * | n | ) |

The window's mouse cursor.

This form of the setter is used to have no mouse cursor given in the class. This should be done if the window dynamically sets the mouse cursor.

Parameters:

  | n | must be `null`.

Since:
  0.51

Status:
  test

deprecated HCURSOR smjg.libs.sdwf.windowbase.WindowClass.cursor | ( |  | ) |

The window's mouse cursor.

Deprecated:
  Superseded by WindowClass.mouseCursor.

deprecated HCURSOR smjg.libs.sdwf.windowbase.WindowClass.cursor | ( | HCURSOR | c | ) |

The window's mouse cursor.

Parameters:

  | c | a raw cursor handle, such as the result of a call to stockCursor.

Deprecated:
  Superseded by WindowClass.mouseCursor.

deprecated HCURSOR smjg.libs.sdwf.windowbase.WindowClass.cursor | ( | uint | id | ) |

The window's mouse cursor.

Parameters:

  | id | numeric ID of the cursor resource.

Deprecated:
  Superseded by WindowClass.mouseCursor.

deprecated HCURSOR smjg.libs.sdwf.windowbase.WindowClass.cursor | ( | string | name | ) |

The window's mouse cursor.

Parameters:

  | name | name of the cursor resource.

Deprecated:
  Superseded by WindowClass.mouseCursor.

HBRUSH smjg.libs.sdwf.windowbase.WindowClass.background | ( |  | ) |

The window's background brush.

Returns:
  the Windows handle of the brush, or the magic value `(systemColour + 1)` if it was set using a COLOUR constant.

HBRUSH smjg.libs.sdwf.windowbase.WindowClass.background | ( | HBRUSH | h | ) |

The window's background brush.

Parameters:

  | h | the Windows handle of the brush to use.

Returns:
  the Windows handle of the chosen brush.

HBRUSH smjg.libs.sdwf.windowbase.WindowClass.background | ( | COLOUR | systemColour | ) |

The window's background colour.

Sets the window's background brush to a colour in the Windows colour scheme.

Parameters:

  | systemColour | constant denoting a colour in the Windows colour scheme.

Returns:
  the magic value `(systemColour + 1)`.

HBRUSH smjg.libs.sdwf.windowbase.WindowClass.background | ( | Brush | b | ) |

The window's background brush.

Parameters:

  | b | brush to use as the background.

Returns:
  the Windows handle of the chosen brush.

HBRUSH smjg.libs.sdwf.windowbase.WindowClass.background | ( | RGBColour | colour | ) |

The window's background colour.

Parameters:

  | colour | colour to use as the background.

Returns:
  the Windows handle of the brush created to use as the background.

Since:
  0.4

Status:
  done

LPCTSTR smjg.libs.sdwf.windowbase.WindowClass.menu | ( |  | ) |

The window's menu bar.

Returns:
  a raw LPCTSTR value as generated from a resource ID.

LPCTSTR smjg.libs.sdwf.windowbase.WindowClass.menu | ( | LPCTSTR | i | ) |

The window's menu bar.

Parameters:

  | i | a raw LPCTSTR value as generated from a resource ID.

Returns:
  a raw LPCTSTR value as generated from a resource ID.

LPCTSTR smjg.libs.sdwf.windowbase.WindowClass.menu | ( | uint | id | ) |

The window's menu bar.

Parameters:

  | id | numeric ID of the menu resource.

Returns:
  a raw LPCTSTR value as generated from a resource ID.

LPCTSTR smjg.libs.sdwf.windowbase.WindowClass.menu | ( | string | name | ) |

The window's menu bar.

Parameters:

  | name | name of the menu resource.

Returns:
  a raw LPCTSTR value as generated from a resource ID.

string smjg.libs.sdwf.windowbase.WindowClass.name | ( |  | ) |

The name by which this window class will be registered.

string smjg.libs.sdwf.windowbase.WindowClass.name | ( | string | n | ) |

The name by which this window class will be registered.

Setting this property is generally not really necessary, as SDWF automatically gives each WindowClass instance a unique name, but it is provided for the sake of completeness.

void smjg.libs.sdwf.windowbase.WindowClass.register | ( |  | ) |

Called by the show method in classes derived from WindowBase to register the class with Windows.

## Member Data Documentation

uint smjg.libs.sdwf.windowbase.WindowClass._size = WNDCLASSEXA.sizeof

CS smjg.libs.sdwf.windowbase.WindowClass.style = CS.OWNDC | CS.HREDRAW | CS.VREDRAW

The window's class style.

WNDPROC smjg.libs.sdwf.windowbase.WindowClass._windowProc = &WindowBase.WindowProc

int smjg.libs.sdwf.windowbase.WindowClass._classExtraBytes = 0

int smjg.libs.sdwf.windowbase.WindowClass._windowExtraBytes = 0

HANDLE smjg.libs.sdwf.windowbase.WindowClass._instanceHandle = null

HICON smjg.libs.sdwf.windowbase.WindowClass._iconHandle = null

HCURSOR smjg.libs.sdwf.windowbase.WindowClass._cursorHandle = null

HBRUSH smjg.libs.sdwf.windowbase.WindowClass._background = cast(HBRUSH) (COLOR_WINDOW + 1)

LPCTSTR smjg.libs.sdwf.windowbase.WindowClass._menuName = null

LPCTSTR smjg.libs.sdwf.windowbase.WindowClass._className = null

HICON smjg.libs.sdwf.windowbase.WindowClass._smallIconHandle = null

WNDCLASSEXA smjg.libs.sdwf.windowbase.WindowClass.wc

The documentation for this class was generated from the following file:

- windowbase.d